src/Entity/Comment.php
<?php

namespace App\Entity;

use App\Repository\CommentRepository;
use Doctrine\ORM\Mapping as ORM;
use Symfony\Component\Security\Core\User\UserInterface\UserInterface;

/**
 * @ORM\Entity(repositoryClass=CommentRepository::class)
 */
class Comment
{
    /**
     * @ORM\Id
     * @ORM\GeneratedValue
     * @ORM\Column(type="integer")
     */
    private $id;

    /**
     * @ORM\Column(type="text")
     */
    private $content;

    /**
     * @ORM\Column(type="datetime")
     */
    private $create_at;

    /**
     * @ORM\Column(type="datetime", nullable=true)
     */
    private $updated_at;

    /**
     * @ORM\Column(type="string", length=255, nullable=true)
     */
    private $ip;

    /**
     * @ORM\Column(type="string", length=255, nullable=true)
     */
    private $user_agent;

    /**
     * @ORM\Column(type="string", length=255, nullable=true)
     */
    private $referer_url;

    /**
     * @ORM\ManyToOne(targetEntity=Post::class, inversedBy="comments")
     * @ORM\JoinColumn(nullable=false)
     */
    private $post;

    /**
     * @ORM\Column(type="string", length=255)
     */
    private $author;

    public function __construct() {
        $this->setCreateAt(new \DateTime());
        $this->setUpdatedAt(new \DateTime());
    }

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getContent(): ?string
    {
        return $this->content;
    }

    public function setContent(string $content): self
    {
        $this->content = $content;

        return $this;
    }

    public function getCreateAt(): ?\DateTimeInterface
    {
        return $this->create_at;
    }

    public function setCreateAt(\DateTimeInterface $create_at): self
    {
        $this->create_at = $create_at;

        return $this;
    }

    public function getUpdatedAt(): ?\DateTimeInterface
    {
        return $this->updated_at;
    }

    public function setUpdatedAt(?\DateTimeInterface $updated_at): self
    {
        $this->updated_at = $updated_at;

        return $this;
    }

    public function getIp(): ?string
    {
        return $this->ip;
    }

    public function setIp(?string $ip): self
    {
        $this->ip = $ip;

        return $this;
    }

    public function getUserAgent(): ?string
    {
        return $this->user_agent;
    }

    public function setUserAgent(?string $user_agent): self
    {
        $this->user_agent = $user_agent;

        return $this;
    }

    public function getRefererUrl(): ?string
    {
        return $this->referer_url;
    }

    public function setRefererUrl(?string $referer_url): self
    {
        $this->referer_url = $referer_url;

        return $this;
    }

    public function getPost(): ?Post
    {
        return $this->post;
    }

    public function setPost(?Post $post): self
    {
        $this->post = $post;

        return $this;
    }

    public function getAuthor(): ?string
    {
        return $this->author;
    }

    public function setAuthor(string $author): self
    {
        $this->author = $author;

        return $this;
    }
    
    /**
     * @ORM\PreUpdate
     */
    public function setUpdatedAtValue() {
        $this->setUpdatedAt(new \DateTime());
    }
}

src/Entity/Post.php
<?php

namespace App\Entity;

use App\Repository\PostRepository;
use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\Common\Collections\Collection;
use Doctrine\ORM\Mapping as ORM;

/**
 * @ORM\Entity(repositoryClass=PostRepository::class)
 */
class Post
{
    /**
     * @ORM\Id
     * @ORM\GeneratedValue
     * @ORM\Column(type="integer")
     */
    private $id;

    /**
     * @ORM\Column(type="string", length=255)
     */
    private $title;

    /**
     * @ORM\Column(type="string", length=99999, nullable=true)
     */
    private $content;

    /**
     * @ORM\Column(type="string", length=255)
     */
    private $author;

    /**
     * @ORM\Column(type="datetime")
     */
    private $created_at;

    /**
     * @ORM\Column(type="datetime", nullable=true)
     */
    private $updated_at;

    /**
     * @ORM\OneToMany(targetEntity=Comment::class, mappedBy="post", orphanRemoval=true)
     */
    private $comments;

    public function __construct()
    {
        $this->comments = new ArrayCollection();
        $this->setCreatedAt(new \DateTime());
        $this->setUpdatedAt(new \DateTime());
    }

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getTitle(): ?string
    {
        return $this->title;
    }

    public function setTitle(string $title): self
    {
        $this->title = $title;

        return $this;
    }

    public function getContent(): ?string
    {
        return $this->content;
    }

    public function setContent(?string $content): self
    {
        $this->content = $content;

        return $this;
    }

    public function getAuthor(): ?string
    {
        return $this->author;
    }

    public function setAuthor(string $author): self
    {
        $this->author = $author;

        return $this;
    }

    public function getCreatedAt(): ?\DateTimeInterface
    {
        return $this->created_at;
    }

    public function setCreatedAt(\DateTimeInterface $created_at): self
    {
        $this->created_at = $created_at;

        return $this;
    }

    public function getUpdatedAt(): ?\DateTimeInterface
    {
        return $this->updated_at;
    }

    public function setUpdatedAt(?\DateTimeInterface $updated_at): self
    {
        $this->updated_at = $updated_at;

        return $this;
    }

    /**
     * @return Collection|Comment[]
     */
    public function getComments(): Collection
    {
        return $this->comments;
    }

    public function addComment(Comment $comment): self
    {
        if (!$this->comments->contains($comment)) {
            $this->comments[] = $comment;
            $comment->setPost($this);
        }

        return $this;
    }

    public function removeComment(Comment $comment): self
    {
        if ($this->comments->removeElement($comment)) {
            // set the owning side to null (unless already changed)
            if ($comment->getPost() === $this) {
                $comment->setPost(null);
            }
        }

        return $this;
    }
    
    public function __toString()
    {
        return $this->getTitle();
    }
}

src/Form/PostType.php
<?php

namespace App\Form;

use App\Entity\Post;
use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolver;
use Symfony\Component\Form\Extension\Core\Type\TextareaType;
use Symfony\Component\Form\Extension\Core\Type\HiddenType;
use Symfony\Component\Security\Core\Security;

class PostType extends AbstractType
{
    private $security;

    public function __construct(Security $security)
    {
        $this->security = $security;
    }

    public function buildForm(FormBuilderInterface $builder, array $options)
    {
        $builder
            ->add('title')
            ->add('content',TextareaType::class)
            ->add('author',HiddenType::class, [
                'data' => $this->security->getUser()->getUsername()
            ]) 
            // ->add('created_at')
            // ->add('updated_at')
        ;
    }

    public function configureOptions(OptionsResolver $resolver)
    {
        $resolver->setDefaults([
            'data_class' => Post::class,
            'allow_extra_fields' => true
        ]);
    }
}

src/Controller/PostController.php
<?php

namespace App\Controller;

use App\Entity\Post;
use App\Form\PostType;
use App\Repository\PostRepository;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Annotation\Route;

/**
 * @Route("/post")
 */
class PostController extends AbstractController
{
    /**
     * @Route("/", name="post_index", methods={"GET"})
     */
    public function index(Request $request, PostRepository $postRepository): Response
    {
        $post = new Post();
        $form = $this->createForm(PostType::class, $post);
        $form->handleRequest($request);

        return $this->render('post/index.html.twig', [
            'posts' => $postRepository->findBy(array(), array('id' => 'DESC')),
            'form' => $form->createView()
        ]);
    }

    /**
     * @Route("/new", name="post_new", methods={"GET","POST"})
     */
    public function new(Request $request): Response
    {
        $post = new Post();
        $form = $this->createForm(PostType::class, $post);
        $form->handleRequest($request);

        if ($form->isSubmitted() && $form->isValid()) {
            $entityManager = $this->getDoctrine()->getManager();
            $entityManager->persist($post);
            $entityManager->flush();
        }

        return $this->redirectToRoute('post_index');
    }
}

templates/post/_comment_block.html.twig
<div class="comment-block">
    <h1 class="comments-title">Comments (<span id="comment_count_{{ post.id }}" class="comment_count">{{ post.comments|length }}</span>)</h1>
    {% for comment in post.comments %}
        <div class="be-comment"  id="comment-content-{{ comment.id }}">
            <div class="comment-content">
                    <span class="comment-name">
                        <a href="#">{{ comment.author }}</a>
                        </span>
                    <span class="comment-time">
                        <i class="fa fa-clock-o"></i>
                        {{ comment.createAt ? comment.createAt|date('Y-m-d H:i:s') : '' }}
                    </span>
                <p class="comment-text">
                    <span>
                        <label id="comment_content_text_{{ comment.id }}">{{ comment.content }}</label>
                    </span>
                    {% if app.user.username == comment.author %}
                        <span class="comment-time">
                            <button type="button" class="btn btn-default btn-sm" onclick="editComment('{{ comment.id }}','{{ post.id }}','{{ comment.content }}')">
                                <i class="fa fa-edit"></i>
                            </button>
                            <button type="button" class="btn btn-default btn-sm" onclick="deleteComment('{{ comment.id }}','{{ post.id }}','{{ comment.content }}')">
                                <i class="fa fa-times"></i>
                            </button>
                        </span>
                    {% endif %}
                </p>
            </div>
        </div>
    {% endfor %}
    <form class="form-block" id="comment-form">
        <div class="input-group">
            <textarea class="form-control" aria-label="With textarea" name="comment[content]" id="comment_content" required="required"></textarea>
            <div class="input-group-append">
                <input type="hidden" value="{{ post.id }}" name="comment[post]">
                <input type="hidden" value="{{ app.user.username }}" name="comment[author]">
                <button type="submit" id="add-comment-{{ post.id }}" class="btn btn-primary add-comment">Add Comment</button>
            </div>
        </div>
    </form>
</div>

templates/post/_delete_comment_modal.html.twig
<!-- Modal Delete Comment-->
<div class="modal fade" id="deleteCommentModal" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel" aria-hidden="true">
    <div class="modal-dialog" role="document">
        <div class="modal-content">
        <div class="modal-header">
            <h5 class="modal-title" id="editCommentModalLabel">Delete Comment</h5>
            <button type="button" class="close" data-dismiss="modal" aria-label="Close">
            <span aria-hidden="true">&times;</span>
            </button>
        </div>
        <form class="form-block" id="delete-comment-form">
            <div class="modal-body">
                <label for="delete_comment_content" class="required">Are you sure you want to delete this comment?</label>
                <textarea id="delete_comment_content" name="comment[content]" class="form-control" readonly></textarea>
                <input type="hidden" name="comment[post]" id="delete_post_id">
                <input type="hidden" id="delete_comment_id">
                {# <input type="hidden" name="_method" value="DELETE"> #}
            </div>
            <div class="modal-footer">
                <button type="button" class="btn btn-secondary" data-dismiss="modal">No</button>
                <button type="submit" class="btn btn-primary">Yes</button>
            </div>
        </form>
        </div>
    </div>
</div>

templates/post/_edit_comment_modal.html.twig
<!-- Modal Edit Comment-->
<div class="modal fade" id="editCommentModal" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel" aria-hidden="true">
    <div class="modal-dialog" role="document">
        <div class="modal-content">
            <div class="modal-header">
                <h5 class="modal-title" id="editCommentModalLabel">Edit Comment</h5>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                <span aria-hidden="true">&times;</span>
                </button>
            </div>
            <form class="form-block" id="edit-comment-form">
                <div class="modal-body">
                        <label for="edit_comment_content" class="required">Comment</label>
                        <textarea id="edit_comment_content" name="comment[content]" required="required" class="form-control"></textarea>
                        <input type="hidden" value="{{ app.user.username }}" name="comment[author]">
                        <input type="hidden" name="comment[post]" id="edit_post_id">
                        <input type="hidden" id="edit_comment_id">
                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
                    <button type="submit" class="btn btn-primary">Save changes</button>
                </div>
            </form>
        </div>
    </div>
</div>

templates/post/_form.html.twig
{{ form_start(form) }}
    {{ form_widget(form) }}
    <button class="btn">{{ button_label|default('Save') }}</button>
{{ form_end(form) }}

templates/post/index.html.twig
{% extends 'base.html.twig' %}

{% block title %}Post index{% endblock %}

{% block body %}
    <div class="container-fluid">
        {{ include('post/new.html.twig') }}
   {% for post in posts %}
        <div class="card mx-auto" style="width: 50rem; margin-bottom: 10px">
            <div class="card-body">
                <h5 class="card-title">{{ post.title }}</h5>
                <p class="card-text">{{ post.content }}</p>
                {{ include('post/_comment_block.html.twig') }}
            </div>
        </div>
        {% else %}
            <div class="card mx-auto" style="width: 50rem;">
                <div class="card-body">
                    <p class="card-text">No Blog Found</p>
                </div>
            </div>
        {% endfor %}
    </div>
    
    {{ include('post/_edit_comment_modal.html.twig') }}
    {{ include('post/_delete_comment_modal.html.twig') }}
    
{% endblock %}
{% block javascripts %}
    
<!-- Optional JavaScript -->
    <!-- jQuery first, then Popper.js, then Bootstrap JS -->
    <script src="https://code.jquery.com/jquery-3.5.1.min.js" crossorigin="anonymous"></script>
    {# <script src="https://code.jquery.com/jquery-3.2.1.slim.min.js" integrity="sha384-KJ3o2DKtIkvYIK3UENzmM7KCkRr/rE9/Qpg6aAZGJwFDMVNA/GpGFF93hXpG5KkN" crossorigin="anonymous"></script> #}
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.12.9/umd/popper.min.js" integrity="sha384-ApNbgh9B+Y1QKtv3Rn7W3mgPxhU9K/ScQsAP7hUibX39j7fakFPskvXusvfa0b4Q" crossorigin="anonymous"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/js/bootstrap.min.js" integrity="sha384-JZR6Spejh4U02d8jOt6vLEHfe/JQGiRRSQQxSfFWpi1MquVdAyjUar5+76PVCmYl" crossorigin="anonymous"></script>
    <script>
        $(function(){
            $('.add-comment').click(function(e) {
                
                e.preventDefault();
                var url = "{{ path('comment_new_ajax') }}";
                var $this = $(this).closest("form");//$(this);
                var formSerialize = $this.serialize();
                var current_comment_count_id = $this.parent().find(".comment_count").attr('id');
                var current_comment_count = parseInt($("#"+current_comment_count_id).text());
                var post_id = $this.parent().find(".comment_count").attr('id').replace('comment_count_','')

                $.post(url, formSerialize, function(response) {
                    //your callback here
                    var elem = $([
                            '<div class="be-comment"  id="comment-content-'+response.data.comment_id+'">',
                                '<div class="comment-content">',
                                        '<span class="comment-name">',
                                            '<a href="#">'+response.data.comment_author+'</a>',
                                            '</span>',
                                        '<span class="comment-time">',
                                            '<i class="fa fa-clock-o"></i>',
                                            response.data.comment_created_at.date,
                                        '</span>',
                                    '<p class="comment-text">',
                                        '<span>',
                                            '<label id="comment_content_text_'+response.data.comment_id+'">'+response.data.comment_content+'</label>',
                                        '</span>',
                                        '<span class="comment-time">',
                                            '<button type="button" class="btn btn-default btn-sm" onclick="editComment('+'&#39;'+response.data.comment_id+'&#39;'+','+'&#39;'+post_id+'&#39;'+')">',
                                                '<i class="fa fa-edit"></i>',
                                            '</button>',
                                            '<button type="button" class="btn btn-default btn-sm" onclick="deleteComment('+'&#39;'+response.data.comment_id+'&#39;'+','+'&#39;'+post_id+'&#39;'+')">',
                                                '<i class="fa fa-times"></i>',
                                            '</button>',
                                        '</span>',
                                    '</p>',
                                '</div>',
                            '</div>'
                        ].join("\n"));
                    if($this.parent().find($('.be-comment div')).length !== 0) {
                        $this.parent().find($('.be-comment div')).last().parent().after(elem);
                    } else {
                        $this.parent().find($('.comments-title')).after(elem);
                    }
                    
                    $("#"+current_comment_count_id).text(current_comment_count+1)
                }, 'JSON');
            });

            $('#edit-comment-form').submit(function(e) {

                e.preventDefault();
                var $this = $(this);
                var id = $this.find('#edit_comment_id').val()
                var url = "{{ path('comment_edit_ajax', { 'id' : 'id-param' }) }}";
                var url = url.replace("id-param", id);
                var formSerialize = $this.serialize();

                $.post(url, formSerialize, function(response) {
                    //your callback here
                    $("#comment_content_text_"+id).text(response.data.comment_content);
                    $('#editCommentModal').modal('toggle');
                }, 'JSON');
            });

            $('#delete-comment-form').submit(function(e) {
                e.preventDefault();
                var $this = $(this);
                var id = $this.find('#delete_comment_id').val()
                var url = "{{ path('comment_delete_ajax', { 'id' : 'id-param' }) }}";
                var url = url.replace("id-param", id);
                var formSerialize = $this.serialize();
                var current_comment_count_id = $this.parent().parent().parent().parent().find(".comment_count").attr('id');
                var current_comment_count = parseInt($("#"+current_comment_count_id).text());
                $.ajax({ url: url, method: 'DELETE', data: formSerialize})
                .then(function (response) {
                    $("#comment-content-"+id).remove();
                    $('#deleteCommentModal').modal('toggle');
                    $("#"+current_comment_count_id).text(current_comment_count-1)
                });
            });
        });

        function editComment(id, post_id) {
            $('#edit_comment_content').val($("#comment_content_text_"+id).text())
            $('#edit_comment_id').val(id)
            $('#edit_post_id').val(post_id)
            $('#editCommentModal').modal('show')
        }

        function deleteComment(id, post_id) {
            $('#delete_comment_content').val($("#comment_content_text_"+id).text())
            $('#delete_comment_id').val(id)
            $('#delete_post_id').val(post_id)
            $('#deleteCommentModal').modal('show')
        }
    </script>
{% endblock %}

templates/post/new.html.twig
<div class="card mx-auto card-write-post" style="width: 50rem; margin-bottom: 10px; margin-top: 20px;">
    <h5 class="card-header">Write a post</h5>
    <div class="card-body">
        {{ form_start(form, { 'action': path('post_new'), 'attr': { 'class': 'form-block', 'enctype': 'multipart/form-data' } }) }}
            {{ form_rest(form) }}
            <button class="btn btn-primary btn-sm btn-block" type="submit" style="margin-top: 10px;">Publish Post</button>
        {{ form_end(form) }}
    </div>
</div>